XMPP::Roster::Item Class Reference

`#include <xmpp_roster.h>`

Inheritance diagram for XMPP::Roster::Item:

## Public Member Functions

| Item (PXMLElement *item=0)
| Item (PXMLElement &item)
| Item (const JID &jid, ItemType type, const PString &group, const PString &name=PString::Empty())
const JID & | GetJID () const
ItemType | GetType () const
const PString & | GetName () const
const PStringSet & | GetGroups () const
const PresenceInfo & | GetPresence () const
virtual void | SetJID (const JID &jid, PBoolean dirty=true)
virtual void | SetType (ItemType type, PBoolean dirty=true)
virtual void | SetName (const PString &name, PBoolean dirty=true)
virtual void | AddGroup (const PString &group, PBoolean dirty=true)
virtual void | RemoveGroup (const PString &group, PBoolean dirty=true)
virtual void | SetPresence (const Presence &p)
void | SetDirty (PBoolean b=true)
Item & | operator= (const PXMLElement &item)
| This operator will set the dirty flag. More...
virtual PXMLElement * | AsXML (PXMLElement *parent) const
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes

BareJID | m_JID
ItemType | m_Type
PString | m_Name
PStringSet | m_Groups
PDictionary< PString, Presence > | m_Presence
PBoolean | m_IsDirty

## Additional Inherited Members

Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Constructor & Destructor Documentation

## Item() [1/3]

XMPP::Roster::Item::Item | ( | PXMLElement * | item = `0` | ) |

## Item() [2/3]

XMPP::Roster::Item::Item | ( | PXMLElement & | item | ) |

## Item() [3/3]

XMPP::Roster::Item::Item | ( | const JID & | jid,
|  | ItemType | type,
|  | const PString & | group,
|  | const PString & | name = `PString::Empty()`
| ) |  |

## Member Function Documentation

## AddGroup()

virtual void XMPP::Roster::Item::AddGroup | ( | const PString & | group,
|  | PBoolean | dirty = `true`
| ) |  |

virtual

Referenced by SetName().

## AsXML()

virtual PXMLElement* XMPP::Roster::Item::AsXML | ( | PXMLElement * | parent | ) | const

virtual

Referenced by SetDirty().

## GetGroups()

const PStringSet& XMPP::Roster::Item::GetGroups | ( |  | ) | const

inline

References m_Groups.

## GetJID()

const JID& XMPP::Roster::Item::GetJID | ( |  | ) | const

inline

References m_JID.

## GetName()

const PString& XMPP::Roster::Item::GetName | ( |  | ) | const

inline

References m_Name.

## GetPresence()

const PresenceInfo& XMPP::Roster::Item::GetPresence | ( |  | ) | const

inline

References m_Presence.

## GetType()

ItemType XMPP::Roster::Item::GetType | ( |  | ) | const

inline

References m_Type.

## operator=()

Item& XMPP::Roster::Item::operator= | ( | const PXMLElement & | item | ) |

This operator will set the dirty flag.

Referenced by SetDirty().

## RemoveGroup()

virtual void XMPP::Roster::Item::RemoveGroup | ( | const PString & | group,
|  | PBoolean | dirty = `true`
| ) |  |

virtual

Referenced by SetName().

## SetDirty()

void XMPP::Roster::Item::SetDirty | ( | PBoolean | b = `true` | ) |

inline

References AsXML(), m_IsDirty, and operator=().

Referenced by SetJID(), SetName(), and SetType().

## SetJID()

virtual void XMPP::Roster::Item::SetJID | ( | const JID & | jid,
|  | PBoolean | dirty = `true`
| ) |  |

inline virtual

References m_JID, and SetDirty().

## SetName()

virtual void XMPP::Roster::Item::SetName | ( | const PString & | name,
|  | PBoolean | dirty = `true`
| ) |  |

inline virtual

References AddGroup(), m_Name, RemoveGroup(), SetDirty(), and SetPresence().

## SetPresence()

virtual void XMPP::Roster::Item::SetPresence | ( | const Presence & | p | ) |

virtual

Referenced by SetName().

## SetType()

virtual void XMPP::Roster::Item::SetType | ( | ItemType | type,
|  | PBoolean | dirty = `true`
| ) |  |

inline virtual

References m_Type, and SetDirty().

## Member Data Documentation

## m_Groups

PStringSet XMPP::Roster::Item::m_Groups

protected

Referenced by GetGroups().

## m_IsDirty

PBoolean XMPP::Roster::Item::m_IsDirty

protected

Referenced by SetDirty().

## m_JID

BareJID XMPP::Roster::Item::m_JID

protected

Referenced by GetJID(), and SetJID().

## m_Name

PString XMPP::Roster::Item::m_Name

protected

Referenced by GetName(), and SetName().

## m_Presence

PDictionary<PString, Presence> XMPP::Roster::Item::m_Presence

protected

Referenced by GetPresence().

## m_Type

ItemType XMPP::Roster::Item::m_Type

protected

Referenced by GetType(), and SetType().

The documentation for this class was generated from the following file:

- xmpp_roster.h